Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jndi
Class JndiObjectFactoryBean

    java.lang.Object
      org.springframework.jndi.JndiAccessor
          org.springframework.jndi.JndiLocatorSupport
              org.springframework.jndi.JndiObjectLocator
                  org.springframework.jndi.JndiObjectFactoryBean

All Implemented Interfaces:
  Aware, BeanClassLoaderAware, FactoryBean<java.lang.Object>, InitializingBean

    public class JndiObjectFactoryBean

extends JndiObjectLocator
implements FactoryBean<java.lang.Object>, BeanClassLoaderAware

`FactoryBean` that looks up a JNDI object. Exposes the object found in JNDI for bean references, e.g. for data access object's "dataSource" property in case of a `DataSource`.

The typical usage will be to register this as singleton factory (e.g. for a certain JNDI-bound DataSource) in an application context, and give bean references to application services that need it.

The default behavior is to look up the JNDI object on startup and cache it. This can be customized through the "lookupOnStartup" and "cache" properties, using a `JndiObjectTargetSource` underneath. Note that you need to specify a "proxyInterface" in such a scenario, since the actual JNDI object type is not known in advance.

Of course, bean classes in a Spring environment may lookup e.g. a DataSource from JNDI themselves. This class simply enables central configuration of the JNDI name, and easy switching to non-JNDI alternatives. The latter is particularly convenient for test setups, reuse in standalone clients, etc.

Note that switching to e.g. DriverManagerDataSource is just a matter of configuration: Simply replace the definition of this FactoryBean with a `DriverManagerDataSource` definition!

Since:
  22.05.2003
Author:
  Juergen Hoeller
See Also:
  `setProxyInterface(java.lang.Class)`, `setLookupOnStartup(boolean)`, `setCache(boolean)`, `JndiObjectTargetSource`

Field Summary

Fields inherited from class org.springframework.jndi.JndiLocatorSupport
`CONTAINER_PREFIX`

Fields inherited from class org.springframework.jndi.JndiAccessor
`logger`

Constructor Summary
`JndiObjectFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Look up the JNDI object and store it.
`protected java.lang.Class` | `createCompositeInterface(java.lang.Class[] interfaces)` Create a composite interface Class for the given interfaces, implementing the given interfaces in one single Class.
`java.lang.Object` | `getObject()` Return the singleton JNDI object.
`java.lang.Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`protected java.lang.Object` | `lookupWithFallback()` Lookup variant that that returns the specified "defaultObject" (if any) in case of lookup failure.
`void` | `setBeanClassLoader(java.lang.ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setCache(boolean cache)` Set whether to cache the JNDI object once it has been located.
`void` | `setDefaultObject(java.lang.Object defaultObject)` Specify a default object to fall back to if the JNDI lookup fails.
`void` | `setExposeAccessContext(boolean exposeAccessContext)` Set whether to expose the JNDI environment context for all access to the target object, i.e.
`void` | `setLookupOnStartup(boolean lookupOnStartup)` Set whether to look up the JNDI object on startup.
`void` | `setProxyInterface(java.lang.Class proxyInterface)` Specify the proxy interface to use for the JNDI object.
`void` | `setProxyInterfaces(java.lang.Class[] proxyInterfaces)` Specify multiple proxy interfaces to use for the JNDI object.

Methods inherited from class org.springframework.jndi.JndiObjectLocator
`getExpectedType, getJndiName, lookup, setExpectedType, setJndiName`

Methods inherited from class org.springframework.jndi.JndiLocatorSupport
`convertJndiName, isResourceRef, lookup, lookup, setResourceRef`

Methods inherited from class org.springframework.jndi.JndiAccessor
`getJndiEnvironment, getJndiTemplate, setJndiEnvironment, setJndiTemplate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JndiObjectFactoryBean

    public JndiObjectFactoryBean()

Method Detail

### setProxyInterface

    public void setProxyInterface(java.lang.Class proxyInterface)

  Specify the proxy interface to use for the JNDI object.

  Typically used in conjunction with "lookupOnStartup"=false and/or "cache"=false. Needs to be specified because the actual JNDI object type is not known in advance in case of a lazy lookup.

  See Also:
    `setProxyInterfaces(java.lang.Class[])`, `setLookupOnStartup(boolean)`, `setCache(boolean)`

### setProxyInterfaces

    public void setProxyInterfaces(java.lang.Class[] proxyInterfaces)

  Specify multiple proxy interfaces to use for the JNDI object.

  Typically used in conjunction with "lookupOnStartup"=false and/or "cache"=false. Note that proxy interfaces will be autodetected from a specified "expectedType", if necessary.

  See Also:
    `JndiObjectLocator.setExpectedType(java.lang.Class)`, `setLookupOnStartup(boolean)`, `setCache(boolean)`

### setLookupOnStartup

    public void setLookupOnStartup(boolean lookupOnStartup)

  Set whether to look up the JNDI object on startup. Default is "true".

  Can be turned off to allow for late availability of the JNDI object. In this case, the JNDI object will be fetched on first access.

  For a lazy lookup, a proxy interface needs to be specified.

  See Also:
    `setProxyInterface(java.lang.Class)`, `setCache(boolean)`

### setCache

    public void setCache(boolean cache)

  Set whether to cache the JNDI object once it has been located. Default is "true".

  Can be turned off to allow for hot redeployment of JNDI objects. In this case, the JNDI object will be fetched for each invocation.

  For hot redeployment, a proxy interface needs to be specified.

  See Also:
    `setProxyInterface(java.lang.Class)`, `setLookupOnStartup(boolean)`

### setExposeAccessContext

    public void setExposeAccessContext(boolean exposeAccessContext)

  Set whether to expose the JNDI environment context for all access to the target object, i.e. for all method invocations on the exposed object reference.

  Default is "false", i.e. to only expose the JNDI context for object lookup. Switch this flag to "true" in order to expose the JNDI environment (including the authorization context) for each method invocation, as needed by WebLogic for JNDI-obtained factories (e.g. JDBC DataSource, JMS ConnectionFactory) with authorization requirements.

### setDefaultObject

    public void setDefaultObject(java.lang.Object defaultObject)

  Specify a default object to fall back to if the JNDI lookup fails. Default is none.

  This can be an arbitrary bean reference or literal value. It is typically used for literal values in scenarios where the JNDI environment might define specific config settings but those are not required to be present.

  Note: This is only supported for lookup on startup.

  See Also:
    `setLookupOnStartup(boolean)`

### setBeanClassLoader

    public void setBeanClassLoader(java.lang.ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws java.lang.IllegalArgumentException,
                                   javax.naming.NamingException

  Look up the JNDI object and store it.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Overrides:
    `afterPropertiesSet` in class `JndiObjectLocator`
  Throws:
    `java.lang.IllegalArgumentException`
    `javax.naming.NamingException`

### lookupWithFallback

    protected java.lang.Object lookupWithFallback()
                                           throws javax.naming.NamingException

  Lookup variant that that returns the specified "defaultObject" (if any) in case of lookup failure.

  Returns:
    the located object, or the "defaultObject" as fallback
  Throws:
    `javax.naming.NamingException` - in case of lookup failure without fallback
  See Also:
    `setDefaultObject(java.lang.Object)`

### getObject

    public java.lang.Object getObject()

  Return the singleton JNDI object.

  Specified by:
    `getObject` in interface `FactoryBean<java.lang.Object>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<?> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<java.lang.Object>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<java.lang.Object>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### createCompositeInterface

    protected java.lang.Class createCompositeInterface(java.lang.Class[] interfaces)

  Create a composite interface Class for the given interfaces, implementing the given interfaces in one single Class.

  The default implementation builds a JDK proxy class for the given interfaces.

  Parameters:
    `interfaces` - the interfaces to merge
  Returns:
    the merged interface as Class
  See Also:
    `Proxy.getProxyClass(java.lang.ClassLoader, java.lang.Class...)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD